// 3DDesignDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "3DDesignDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// C3DDesignDlg dialog


C3DDesignDlg::C3DDesignDlg(CWnd* pParent /*=NULL*/)
	: CDialog(C3DDesignDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(C3DDesignDlg)
	m_ApplyTo = -1;
	m_FileName = _T("");
	//}}AFX_DATA_INIT
	group = NULL;
}


void C3DDesignDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(C3DDesignDlg)
	DDX_Control(pDX, IDC_ECHOAMP, m_EchoAmp);
	DDX_CBIndex(pDX, IDC_APPLYTO, m_ApplyTo);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(C3DDesignDlg, CDialog)
	//{{AFX_MSG_MAP(C3DDesignDlg)
	ON_BN_CLICKED(IDC_OPENEDITOR, OnOpeneditor)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// C3DDesignDlg message handlers

void C3DDesignDlg::OnOpeneditor() 
{
	// TODO: Add your control notification handler code here
	ShellExecute(this->m_hWnd, "open", "3DEditor.exe", "", "", SW_SHOW);
}

BOOL C3DDesignDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CSliderCtrl *sl;
	
	// TODO: Add extra initialization here
	
	if (!m_ApplyTo)
	{
		CComboBox *cb = (CComboBox *)GetDlgItem(IDC_APPLYTO);
		cb->DeleteString(1);
	}
	sl = (CSliderCtrl *)GetDlgItem(IDC_ECHOAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(80);
	sl->SetTicFreq(6);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void C3DDesignDlg::OnBrowse() 
{
	// TODO: Add your control notification handler code here
	CFileDialog o(true, "fil", NULL, OFN_HIDEREADONLY,
		"   (*.e3d)|*.e3d|  (*.*)|*.*||",
		this);

	if (o.DoModal() != IDOK) return;
	m_FileName = o.GetPathName();	
	UpdateData(false);
}

void C3DDesignDlg::GetKernel(double *kernel)
{
	int i, index;
	double c = time_limit * 0.001 / groups * m_SmpRate;
	double amp = pow(10, -pos * 0.05);
	memset(kernel, 0, sizeof(double) * m_KernelSize);
	for (i = 0; i < groups; i++)
	{
		index = int(i * c);
		kernel[index] = group[i] * amp;
	}
}

void C3DDesignDlg::OnOK() 
{
	// TODO: Add extra validation here
	CFile f(m_FileName, CFile::modeRead);
	CArchive ar(&f, CArchive::load);
	CString sig;

	m_KernelSize = 0;
	ar >> sig;
	if (sig != _T("EFFECT"))
		AfxThrowArchiveException(CArchiveException::badIndex, m_FileName);

	ar.Read(&groups, sizeof(int));
	ar.Read(&time_limit, sizeof(double));
	if (group) delete group;
	group = new double[groups];
	ar.Read(group, sizeof(double) * groups);

	ar.Close();
	f.Close();

	m_KernelSize = (int)ceil(time_limit * m_SmpRate / 1000);

	pos = m_EchoAmp.GetPos();
	CDialog::OnOK();
}

void C3DDesignDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int pos;
	double p;

	char s[20];

	pos = -m_EchoAmp.GetPos();
	if (pos > -80)
	{
		p = pow(10, (double)pos / 20) * 100;
		sprintf(s, "%d \n(%.2f%c)", pos, p, '%');
	}
	else
		strcpy(s, "-Inf \n(0%)");
	SetDlgItemText(IDC_VAL2, s);
	
	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void C3DDesignDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_ECHOAMP));
}
