// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "DSP.h"
#include "MainFrm.h"
#include <afxadv.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "DSPDoc.h"

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_PLAYTOOLBAR, OnViewPlaytoolbar)
	ON_COMMAND(ID_VIEW_VIEWTOOLBAR, OnViewViewtoolbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_PLAYTOOLBAR, OnUpdateViewPlaytoolbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_VIEWTOOLBAR, OnUpdateViewViewtoolbar)
	ON_COMMAND(ID_VIEW_FILTERTOOLBAR, OnViewFiltertoolbar)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FILTERTOOLBAR, OnUpdateViewFiltertoolbar)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
};

static UINT indicators2[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_SEPARATOR,           // status line indicator
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	CRect rect;
	int x, y, cx, cy;
	
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (LoadRect("MainWindow", x, y, cx, cy))
	{
		HDC DC = CreateDC("DISPLAY", NULL, NULL, NULL);

		int sw = GetDeviceCaps(DC, HORZRES);
		int sh = GetDeviceCaps(DC, VERTRES);

		DeleteDC(DC);

		if (x < 0) x = 0;
		if (y < 0) y = 0;

		if (cx > sw) cx = sw;
		if (cy > sh) cy = sh;

		SetWindowPos(NULL, x, y, cx, cy, SWP_NOREDRAW);
	}
	else
		CenterWindow();

	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndPlayToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_BOTTOM
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndPlayToolBar.LoadToolBar(IDR_PLAYBUTTONS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndViewToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_BOTTOM
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndViewToolBar.LoadToolBar(IDR_VIEWBUTTONS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndFilterToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_BOTTOM
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndFilterToolBar.LoadToolBar(IDR_FILTERBUTTONS))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	m_wndStatusBar.SetPaneInfo(1, ID_SEPARATOR, SBPS_NORMAL, 30);
	m_wndStatusBar.SetPaneInfo(2, ID_SEPARATOR, SBPS_NORMAL, 60);
	m_wndStatusBar.SetPaneInfo(3, ID_SEPARATOR, SBPS_NORMAL, 60);
	m_wndStatusBar.SetPaneInfo(4, ID_SEPARATOR, SBPS_NORMAL, 60);
	m_wndStatusBar.SetPaneInfo(5, ID_SEPARATOR, SBPS_NORMAL, 60);
	m_wndStatusBar.SetPaneInfo(6, ID_SEPARATOR, SBPS_NORMAL, 40);
	m_wndStatusBar.SetPaneInfo(7, ID_SEPARATOR, SBPS_NORMAL, 40);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.SetWindowText(_T(""));
	m_wndPlayToolBar.SetWindowText(_T(""));
	m_wndViewToolBar.SetWindowText(_T(" "));
	m_wndFilterToolBar.SetWindowText(_T(""));
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndPlayToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndViewToolBar.EnableDocking(CBRS_ALIGN_ANY);
	m_wndFilterToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	DockControlBar(&m_wndPlayToolBar);
	DockControlBar(&m_wndViewToolBar);
	DockControlBar(&m_wndFilterToolBar);
	RecalcLayout();
	m_wndPlayToolBar.GetWindowRect(&rect);
	rect.OffsetRect(1, 0);
	DockControlBar(&m_wndViewToolBar, AFX_IDW_DOCKBAR_BOTTOM, &rect);
	RecalcLayout();
	m_wndViewToolBar.GetWindowRect(&rect);
	rect.OffsetRect(1, 0);
	DockControlBar(&m_wndFilterToolBar, AFX_IDW_DOCKBAR_BOTTOM, &rect);	

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	WNDCLASSEX wClass;
	GetClassInfoEx(cs.hInstance, cs.lpszClass, &wClass);
	wClass.hCursor = LoadCursor(NULL, MAKEINTRESOURCE(IDC_IBEAM));

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnViewPlaytoolbar() 
{
	// TODO: Add your command handler code here
	ShowControlBar(&m_wndPlayToolBar, (m_wndPlayToolBar.GetStyle() & WS_VISIBLE) == 0, FALSE);
	RecalcLayout();
}

void CMainFrame::OnViewViewtoolbar() 
{
	// TODO: Add your command handler code here
	ShowControlBar(&m_wndViewToolBar, (m_wndViewToolBar.GetStyle() & WS_VISIBLE) == 0, FALSE);
	RecalcLayout();
}

void CMainFrame::OnUpdateViewPlaytoolbar(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck((m_wndPlayToolBar.GetStyle() & WS_VISIBLE) != 0);
}

void CMainFrame::OnUpdateViewViewtoolbar(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck((m_wndViewToolBar.GetStyle() & WS_VISIBLE) != 0);
}

void CMainFrame::OnViewFiltertoolbar() 
{
	// TODO: Add your command handler code here
	ShowControlBar(&m_wndFilterToolBar, (m_wndFilterToolBar.GetStyle() & WS_VISIBLE) == 0, FALSE);
	RecalcLayout();	
}

void CMainFrame::OnUpdateViewFiltertoolbar(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
    pCmdUI->SetCheck((m_wndFilterToolBar.GetStyle() & WS_VISIBLE) != 0);
}

void CMainFrame::OnClose() 
{
	// TODO: Add your message handler code here and/or call default
	CRect r;

	GetWindowRect(r);
	SaveRect("MainWindow", r);	

	CFrameWnd::OnClose();
}

bool CMainFrame::LoadRect(char *regkey, int& x, int& y, int& cx, int& cy)
{
	CWinApp *theApp = AfxGetApp();
	x = theApp->GetProfileInt(regkey, "x", -32000);
	y = theApp->GetProfileInt(regkey, "y", -32000);
	cx = theApp->GetProfileInt(regkey, "Width", -32000);
	cy = theApp->GetProfileInt(regkey, "Height", -32000);

	if (x == -32000 || y == -32000 || cx == -32000 || cy == -32000)
		return false;

	return true;
}

void CMainFrame::SaveRect(char *regkey, CRect r)
{
	CWinApp *theApp = AfxGetApp();
	theApp->WriteProfileInt(regkey, "x", r.left);
	theApp->WriteProfileInt(regkey, "y", r.top);
	theApp->WriteProfileInt(regkey, "Width", r.Width());
	theApp->WriteProfileInt(regkey, "Height", r.Height());
}
